package lc.syntax.tree;

import java.util.OptionalInt;
import java.util.stream.Stream;

public sealed interface Term permits Abstraction, Application, Variable {

    Stream<String> free();

    Term substitute(final String name, final Term term);

    String show(final boolean numbers);

    static Term fromNumber(final int number) {
        Term term = new Variable("x");

        for (int i = 0; i < number; ++i) {
            term = new Application(new Variable("f"), term);
        }

        return new Abstraction("f", new Abstraction("x", term));
    }
    OptionalInt toNumber();

}
