package lc.syntax.tree;

import java.util.Objects;
import java.util.OptionalInt;
import java.util.stream.Stream;

public record Variable(String name) implements Term {

    @Override
    public Stream<String> free() {
        return Stream.of(this.name);
    }

    @Override
    public Term substitute(final String name, final Term term) {
        if (Objects.equals(this.name, name)) {
            // replace this variable by the provided term
            return term;
        } else {
            return this;
        }
    }

    @Override
    public String show(final boolean numbers) {
        return Objects.toString(this.name);
    }

    @Override
    public OptionalInt toNumber() {
        return OptionalInt.empty();
    }

}
